///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBCONTACTSDeleteManualContactsArg;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `DeleteManualContactsArg` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBCONTACTSDeleteManualContactsArg : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// List of manually added contacts to be deleted.
@property (nonatomic, readonly) NSArray<NSString *> *emailAddresses;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param emailAddresses List of manually added contacts to be deleted.
///
/// @return An initialized instance.
///
- (instancetype)initWithEmailAddresses:(NSArray<NSString *> *)emailAddresses;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DeleteManualContactsArg` struct.
///
@interface DBCONTACTSDeleteManualContactsArgSerializer : NSObject

///
/// Serializes `DBCONTACTSDeleteManualContactsArg` instances.
///
/// @param instance An instance of the `DBCONTACTSDeleteManualContactsArg` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBCONTACTSDeleteManualContactsArg` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBCONTACTSDeleteManualContactsArg *)instance;

///
/// Deserializes `DBCONTACTSDeleteManualContactsArg` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBCONTACTSDeleteManualContactsArg` API object.
///
/// @return An instantiation of the `DBCONTACTSDeleteManualContactsArg` object.
///
+ (DBCONTACTSDeleteManualContactsArg *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
