///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGAdminConsoleAppPermission;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `AdminConsoleAppPermission` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGAdminConsoleAppPermission : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMLOGAdminConsoleAppPermissionTag` enum type represents the
/// possible tag states with which the `DBTEAMLOGAdminConsoleAppPermission`
/// union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMLOGAdminConsoleAppPermissionTag){
    /// (no description).
    DBTEAMLOGAdminConsoleAppPermissionDefaultForListedApps,

    /// (no description).
    DBTEAMLOGAdminConsoleAppPermissionDefaultForUnlistedApps,

    /// (no description).
    DBTEAMLOGAdminConsoleAppPermissionOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMLOGAdminConsoleAppPermissionTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "default_for_listed_apps".
///
/// @return An initialized instance.
///
- (instancetype)initWithDefaultForListedApps;

///
/// Initializes union class with tag state of "default_for_unlisted_apps".
///
/// @return An initialized instance.
///
- (instancetype)initWithDefaultForUnlistedApps;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value
/// "default_for_listed_apps".
///
/// @return Whether the union's current tag state has value
/// "default_for_listed_apps".
///
- (BOOL)isDefaultForListedApps;

///
/// Retrieves whether the union's current tag state has value
/// "default_for_unlisted_apps".
///
/// @return Whether the union's current tag state has value
/// "default_for_unlisted_apps".
///
- (BOOL)isDefaultForUnlistedApps;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMLOGAdminConsoleAppPermission` union.
///
@interface DBTEAMLOGAdminConsoleAppPermissionSerializer : NSObject

///
/// Serializes `DBTEAMLOGAdminConsoleAppPermission` instances.
///
/// @param instance An instance of the `DBTEAMLOGAdminConsoleAppPermission` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGAdminConsoleAppPermission` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGAdminConsoleAppPermission *)instance;

///
/// Deserializes `DBTEAMLOGAdminConsoleAppPermission` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGAdminConsoleAppPermission` API object.
///
/// @return An instantiation of the `DBTEAMLOGAdminConsoleAppPermission` object.
///
+ (DBTEAMLOGAdminConsoleAppPermission *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
